conf_module conflog

_conflog="configure.log"
rm -f $_conflog

# colors

case "$TERM" in
    xterm|linux)
        _echo_bold="[1m"
        _echo_red="[31m"
        _echo_green="[32m"
        _echo_yellow="[33m"
        _echo_cyan="[36m"
        _echo_normal="[0m[39m"
        ;;
    *)
        _echo_bold=""
        _echo_normal=""
        ;;
esac

conf_test_conflog() {
    echo "${_echo_cyan}writing logs to $_conflog$_echo_normal"

    conf_mark_test_done conflog
}

# global check functions

echocheck() {
#    echocheckreal "checking for $@"
    echocheckreal "$@"
}

# same as with printing command line options: don't depend on \r, printf, etc.
echocheckreal() {
    echo "========== $@ ==========" >> "$_conflog"
    case "$@" in
    ?) echo $_echo_n "$@                               $_echo_c" ;;
    ??) echo $_echo_n "$@                              $_echo_c" ;;
    ???) echo $_echo_n "$@                             $_echo_c" ;;
    ????) echo $_echo_n "$@                            $_echo_c" ;;
    ?????) echo $_echo_n "$@                           $_echo_c" ;;
    ??????) echo $_echo_n "$@                          $_echo_c" ;;
    ???????) echo $_echo_n "$@                         $_echo_c" ;;
    ????????) echo $_echo_n "$@                        $_echo_c" ;;
    ?????????) echo $_echo_n "$@                       $_echo_c" ;;
    ??????????) echo $_echo_n "$@                      $_echo_c" ;;
    ???????????) echo $_echo_n "$@                     $_echo_c" ;;
    ????????????) echo $_echo_n "$@                    $_echo_c" ;;
    ?????????????) echo $_echo_n "$@                   $_echo_c" ;;
    ??????????????) echo $_echo_n "$@                  $_echo_c" ;;
    ???????????????) echo $_echo_n "$@                 $_echo_c" ;;
    ????????????????) echo $_echo_n "$@                $_echo_c" ;;
    ?????????????????) echo $_echo_n "$@               $_echo_c" ;;
    ??????????????????) echo $_echo_n "$@              $_echo_c" ;;
    ???????????????????) echo $_echo_n "$@             $_echo_c" ;;
    ????????????????????) echo $_echo_n "$@            $_echo_c" ;;
    ?????????????????????) echo $_echo_n "$@           $_echo_c" ;;
    ??????????????????????) echo $_echo_n "$@          $_echo_c" ;;
    ???????????????????????) echo $_echo_n "$@         $_echo_c" ;;
    ????????????????????????) echo $_echo_n "$@        $_echo_c" ;;
    ?????????????????????????) echo $_echo_n "$@       $_echo_c" ;;
    ??????????????????????????) echo $_echo_n "$@      $_echo_c" ;;
    ???????????????????????????) echo $_echo_n "$@     $_echo_c" ;;
    ????????????????????????????) echo $_echo_n "$@    $_echo_c" ;;
    ?????????????????????????????) echo $_echo_n "$@   $_echo_c" ;;
    ??????????????????????????????) echo $_echo_n "$@  $_echo_c" ;;
    ???????????????????????????????) echo $_echo_n "$@ $_echo_c" ;;
    *) echo $_echo_n "$@ $_echo_c" ;;
#    *)  echo "$@"
#        echo $_echo_n "                                $_echo_c" ;;
    esac
}

echores() {
    echo "Result is: $@ ($_res_comment)" >> "$_conflog"
    echo "########################################" >> "$_conflog"
    echo "" >> "$_conflog"
    case "$@" in
        yes|found*)             _echo_tmp="$_echo_bold$_echo_green" ;;
        no|not\ found*|fail*)    _echo_tmp="$_echo_bold$_echo_red" ;;
        *)                      _echo_tmp="$_echo_bold" ;;
    esac
    if test -n "$_res_comment" ; then
        echo $_echo_n "[$_echo_tmp$@$_echo_normal] $_echo_c"
        echo "($_echo_yellow$_res_comment$_echo_normal)"
        _res_comment=""
    else
        echo "[$_echo_tmp$@$_echo_normal]"
    fi
}
