conf_module defines

_defines=
_undefines=

# conf_add_define label value

conf_add_define() {
    value=$2
    test -z "$value" && value=1
    _defines="$_defines ;$1;$value;"
}

# conf_add_undefine label

conf_add_undefine() {
    _undefines="$_undefines ;$1;"
}

# output list of defines suitable for .h file
conf_output_defines_h() {
    for i in $_defines ; do
        label=`echo $i | cut_fast ';' 2`
        value=`echo $i | cut_fast ';' 3`
        echo "#define $label $value"
    done
}

# output list of undefines suitable for .h file
conf_output_undefines_h() {
    for i in $_undefines ; do
        label=`echo $i | cut_fast ';' 2`
        echo "#undef $label"
    done
}

# output list of defines suitable for .mak file
conf_output_defines_mak() {
    for i in $_defines ; do
        label=`echo $i | cut_fast ';' 2`
        value=`echo $i | cut_fast ';' 3`
        echo "$label = $value"
    done
}

# output list of undefines suitable for .mak file
conf_output_undefines_mak() {
    for i in $_undefines ; do
        label=`echo $i | cut_fast ';' 2`
        echo "$label = 0"
    done
}

# debug functions
conf_print_defines() {
    echo "defines: $_defines"
}

conf_print_undefines() {
    echo "undefines: $_undefines"
}
