conf_module init

conf_init_default_sections() {

    conf_add_sections \
        "configuration;Configuration:;\
        |installation;Installation directories:;\
        |finetuning;By default, 'make install' will install all the files in\\\n\
'/usr/local/bin', '/usr/local/lib' etc. You can specify\\\n\
an installation prefix other than '/usr/local' using --prefix',\\\n\
for instance '--prefix=/home/dilbert'.\\\n\\\n\
For better control, use the options below.\\\n\\\n\
Fine tuning of the installation directories:;\
        |expert;Expert options:;\
        |optional;Optional features:;"

}

conf_init_default_options() {

    conf_add_options "configuration" \
        "--help;_help;display this help and exit;\
        |-h;_help; ;\
        |--quiet;_quiet;do not print \"checking...\" messages;\
        |--silent;_quiet; ;\
        |-q;_quiet; ;"


    conf_add_options "installation" \
        "--prefix=PREFIX;_prefix;install architecture-independent files in PREFIX\\\n\\\t\\\t\\\t[/usr/local];\
        |--exec-prefix=EPREFIX;_eprefix;install architecture-dependent files in EPREFIX\\\n\\\t\\\t\\\t[PREFIX];"

    conf_add_options "finetuning" \
        "--bindir=DIR;_bindir;user executables [EPREFIX/bin];\
        |--sbindir=DIR;_sbindir;system admin executables [EPREFIX/sbin];\
        |--libexecdir=DIR;_libexecdir;program executables [EPREFIX/libexec];\
        |--datadir=DIR;_datadir;read-only architecture-independent data [PREFIX/share];\
        |--sysconfdir=DIR;_sysconfdir;read-only single machine data [PREFIX/etc];\
        |--sharedstatedir=DIR;_sharedstatedir;modifiable architecture-independent data [PREFIX/com];\
        |--localstatedir=DIR;_localstatedir;modifiable single-machine data [PREFIX/var];\
        |--libdir=DIR;_libdir;object code libraries [EPREFIX/lib];\
        |--includedir=DIR;_includedir;C header files [PREFIX/include];\
        |--infodir=DIR;_infodir;info documentation [PREFIX/info];\
        |--mandir=DIR;_mandir;man documentation [PREFIX/man];"
}

conf_init() {
    conf_init_default_sections
    conf_init_default_options
    conf_local_init
}

# call after initialization and parsing the command line

conf_post_init() {
    # always load conflog module, avoid having conf_depends_on conflog in
    # every single module (slows down a little)
    conf_depends_on conflog
}
