conf_module output

# conf_output_config_h
#
# write config.h file
#
# write output to config.h.new. if it differs from config.h, rename
# config.h to config.h.old and rename config.h.new to config.h
# if they don't differ, delete config.h.new

conf_output_config_h() {
    echo "${_echo_cyan}writing config.h$_echo_normal"

    echo "/* ---------- Generated by configure ---------- */" > config.h.new

    conf_output_defines_h >> config.h.new
    conf_output_undefines_h >> config.h.new

    conf_local_config_h >> config.h.new

    diff config.h config.h.new 2>/dev/null 1>&2

    if test "$?" = "0" ; then 
        rm -f config.h.new
    else
        mv config.h config.h.old 2>/dev/null
        mv config.h.new config.h
    fi
}

# same for config.mak (see above)

conf_output_config_mak() {
    echo "${_echo_cyan}writing config.mak${_echo_normal}"

    echo "# ---------- Generated by configure ----------" > config.mak.new

    {
    test -n "$_cc" && echo "CC = $_cc"
    test -n "$_cxx" && echo "CXX = $_cxx"
    test -n "$_as" && echo "AS = $_as"
    test -n "$_ar" && echo "AR = $_ar" || echo "AR = :"
    test -n "$_ranlib" && echo "RANLIB = $_ranlib" || echo "RANLIB = :"
    test -n "$_ld" && echo "LD = $_ld" || echo "LD = \$(CC)"
    test -n "$_cppfordeps" && echo "CPPFORDEPS = $_cppfordeps"
    test -n "$_make" && echo "MAKE = $_make"
    test -n "$_makedepend" && echo "MAKEDEPEND = $_makedepend"
    test -n "$_cc_optimize" && echo "CFLAGS += $_cc_optimize"
    test -n "$_cc_tune" && echo "CFLAGS += $_cc_tune"
    test -n "$_cc_pipe" && echo "CFLAGS += $_cc_pipe"
    test -n "$_cxx_optimize" && echo "CXXFLAGS += $_cxx_optimize"
    test -n "$_cxx_tune" && echo "CXXFLAGS += $_cxx_tune"
    test -n "$_cxx_pipe" && echo "CXXFLAGS += $_cxx_pipe"
    test -n "$_cppflags" && echo "CPPFLAGS += $_cppflags"
    echo "ASFLAGS = "
    echo "ARFLAGS = "
    test -z "$_prefix" &&         echo "PREFIX = \$(DESTDIR)/usr/local" ||
                                  echo "PREFIX = \$(DESTDIR)$_prefix"
    test -z "$_eprefix" &&        echo "EPREFIX = \$(PREFIX)" ||
                                  echo "EPREFIX = \$(DESTDIR)$_eprefix"
    test -z "$_bindir" &&         echo "BINDIR = \$(EPREFIX)/bin" ||
                                  echo "BINDIR = \$(DESTDIR)$_bindir"
    test -z "$_sbindir" &&        echo "SBINDIR = \$(EPREFIX)/sbin" ||
                                  echo "SBINDIR = \$(DESTDIR)$_sbindir"
    test -z "$_libexecdir" &&     echo "LIBEXECDIR = \$(EPREFIX)/libexec" ||
                                  echo "LIBEXECDIR = \$(DESTDIR)$_libexecdir"
    test -z "$_datadir" &&        echo "DATADIR = \$(PREFIX)/share" ||
                                  echo "DATADIR = \$(DESTDIR)$_datadir"
    test -z "$_sysconfdir" &&     echo "SYSCONFDIR = \$(PREFIX)/etc" ||
                                  echo "SYSCONFDIR = \$(DESTDIR)$_sysconfdir"
    test -z "$_sharedstatedir" && echo "SHAREDSTATEDIR = \$(PREFIX)/com" ||
                          echo "SHAREDSTATEDIR = \$(DESTDIR)$_sharedstatedir"
    test -z "$_localstatedir" &&  echo "LOCALSTATEDIR = \$(PREFIX)/var" ||
                          echo "LOCALSTATEDIR = \$(DESTDIR)$_localstatedir"
    test -z "$_libdir" &&         echo "LIBDIR = \$(EPREFIX)/lib" ||
                                  echo "LIBDIR = \$(DESTDIR)$_libdir"
    test -z "$_includedir" &&     echo "INCLUDEDIR = \$(PREFIX)/include" ||
                                  echo "INCLUDEDIR = \$(DESTDIR)$_includedir"
    test -z "$_infodir" &&        echo "INFODIR = \$(PREFIX)/info" ||
                                  echo "INFODIR = \$(DESTDIR)$_infodir"
    test -z "$_mandir" &&         echo "MANDIR = \$(PREFIX)/man" ||
                                  echo "MANDIR = \$(DESTDIR)$_mandir"
    } >> config.mak.new

    conf_output_defines_mak >> config.mak.new
    conf_output_undefines_mak >> config.mak.new

    conf_local_config_mak >> config.mak.new

    diff config.mak config.mak.new 2>/dev/null 1>&2

    if test "$?" = "0" ; then 
        rm -f config.mak.new
    else
        mv config.mak config.mak.old 2>/dev/null
        mv config.mak.new config.mak
    fi
}
