conf_module cc_optimize

_cc_optimize=

conf_test_cc_optimize() {
    conf_depends_on cc
    conf_depends_on debug

    tmp=$1
    test -n "$_debug" && tmp=debug

    case "$_cc_vendor" in
    suncc)
        case "$tmp" in
        none|debug) _cc_optimize= ;;
        size)       _cc_optimize=-xspace ;;
        low)        _cc_optimize=-xO1 ;;
        high)       _cc_optimize=-xO4 ;;
        extreme)    _cc_optimize=-xO5 ;;
        medium|*)   _cc_optimize=-xO3 ;;
        esac
        ;;
    gnu|icc|tcc)    # tcc ignores -O options for now (version 0.9.22)
        case "$tmp" in
        none|debug) _cc_optimize=-O0 ;;
        size)       _cc_optimize=-Os ;;
        low)        _cc_optimize=-O1 ;;
        high)       _cc_optimize=-O3 ;;
        extreme)    _cc_optimize=-O3 ;;
        medium|*)   _cc_optimize=-O2 ;;
        esac
        ;;
    *)
        _cc_optimize=-O
        ;;
    esac

    echocheck "generic $_cc optimization"
    if test -n "$tmp" ; then
        _res_comment="using $_cc_optimize"
        echores "$tmp"
    else
        _res_comment="using $_cc_optimize"
        echores "medium"
    fi
}
