conf_module cc_run

# before somebody asks, *_i is input, *_o is output :)
_cc_run_i=
_cc_run_o=

conf_test_cc_run() {
    conf_depends_on cc

    test -z "$_cc" &&
        die "There is no C compiler, so I can't do any further checks!"

    conf_depends_on tempdir

    test -z "$_tempdir" &&
        die "There is no temporary diskspace available, so I can't do any further checks!"

    _cc_run_i="$_tempdir/conf-test-$$.c"
    _cc_run_o="$_tempdir/conf-test-$$.o"
    rm -f $_cc_run_i $_cc_run_o

    conf_depends_on ldd

    conf_mark_test_done cc_run
}

cc_run() {
    echo >> $_conflog
    cat $_cc_run_i >> $_conflog
    echo >> $_conflog
    echo "$_cc $CFLAGS $CPPFLAGS $_inc_extra $_lib_extra -o $_cc_run_o $@" >> $_conflog
    rm -f $_cc_run_o
    $_cc $CFLAGS $CPPFLAGS $_inc_extra $_lib_extra -o $_cc_run_o $@ >> $_conflog 2>&1 || return
    echo >> $_conflog
    if test -n "$_ldd" ; then
        echo "ldd $_cc_run_o" >> $_conflog
        $_ldd $_cc_run_o >> $_conflog 2>&1
        echo >> $_conflog
    fi
}
