conf_module cheader

# conf_test_cheader headerfile "test sourcecode" "pre-includes"
#
# checks for headerfile and adds (un)defines to our lists
# keep in mind that if, for example, \n is need, it needs to be escaped!
# also, you have to OMIT the .h for the headerfile

conf_test_cheader() {
    conf_depends_on cc_run
    conf_depends_on toupper

    echocheck "$1.h"

    echo $_echo_e "$3" > $_cc_run_i

    echo "#include <$1.h>" >> $_cc_run_i

    if test -z "$2" ; then
        echo "int main(void){return 0;}" >> $_cc_run_i
    else
        echo $_echo_e "$2" >> $_cc_run_i
    fi

    case $1 in
        */*/*/*)    die $_echo_e "\nbug in configure! cannot test for $1" ;;
        */*/*)  i=`echo $1 | cut_fast '/' 1`
                j=`echo $1 | cut_fast '/' 2`
                k=`echo $1 | cut_fast '/' 3`
                k="${i}_${j}_$k" ;;
        */*)    i=`echo $1 | cut_fast '/' 1`
                j=`echo $1 | cut_fast '/' 2`
                k="${i}_$j" ;;
        *)      k="$1" ;;
    esac

    eval _have_${k}_h=
    cc_run $_cc_run_i && eval _have_${k}_h=yes

    K=`echo $k | $_toupper`
    if eval test -n \"\$_have_${k}_h\" ; then
        conf_add_define HAVE_${K}_H
        echores "yes"
    else
        conf_add_undefine HAVE_${K}_H
        echores "no"
    fi

    conf_mark_test_done "cheader:$1"
    eval test -n \"$_have_${k}_h\"
}

