conf_module clib

# conf_test_clib library "test sourcecode"
#
# checks for library and adds (un)defines to our lists
# keep in mind that if, for example, \n is need, it needs to be escaped!
# also, you have to OMIT the -lm for the libraryname

conf_test_clib() {
    conf_depends_on cc_run
    conf_depends_on toupper

    echocheck "lib$1"

    if test -z "$2" ; then
        echo "int main(void){return 0;}" > $_cc_run_i
    else
        echo $_echo_e "$2" > $_cc_run_i
    fi

    k=$1

    eval _have_lib$k=
    cc_run $_cc_run_i -l$k && eval _have_lib$k=yes

    K=`echo $k | $_toupper`
    if eval test -n \"\$_have_lib$k\" ; then
        conf_add_define HAVE_LIB$K
        eval _lib_$k=-l$k
        echores "yes"
    else
        conf_add_undefine HAVE_LIB$K
        echores "no"
    fi

    conf_mark_test_done "clib:$k"
    eval test -n \"$_have_lib$1\"
}
