conf_module cpu_kernel

_cpu_kernel=1

conf_test_cpu_kernel() {
    conf_depends_on cpu
    conf_depends_on toupper
    conf_depends_on cross_compile
    conf_depends_on cc_run

    SAVEIFS="$IFS"
    IFS=" ,"
    for i in $_cpu_features ; do
        case $i in
        mmx|mmxext|3dnow|3dnowext|sse|sse2|mtrr|altivec)
            if test "$_cross_compile" = "yes" ; then
                echocheck "$_cc support for $i"
            else
                echocheck "os/$_cc support for $i"
            fi
            case $i in
                mmx)        conf_try_cpu_kernel $i "emms" ;;
                mmxext)     conf_try_cpu_kernel $i "sfence" ;;
                3dnow)      conf_try_cpu_kernel $i "femms" ;;
                3dnowext)   conf_try_cpu_kernel $i "pswapd %mm0, %mm0" ;;
                sse)        conf_try_cpu_kernel $i "xorps %xmm0, %xmm0" ;;
                sse2)       conf_try_cpu_kernel $i "xorpd %xmm0, %xmm0" ;;
                mtrr)       test 1 -eq 1 ;; # FIXME: ???
                altivec)    test 1 -eq 1 ;; # FIXME: ???
            esac
            if test $? -eq 0 ; then
                echores "yes"
                j=`echo $i | $_toupper`
                conf_add_define HAVE_$j
            else
                echores "no"
                j=`echo $i | $_toupper`
                conf_add_undefine HAVE_$j
            fi
        esac
    done

    IFS="$SAVEIFS"
    conf_mark_test_done cpu_kernel
}

conf_try_cpu_kernel() {
    cat > $_cc_run_i <<EOF
#include <signal.h>
void catch(int i) { exit(1); }
int main(void) {
    signal(SIGILL, catch);
    asm("$2");
    return 0;
}
EOF

    cc_run $_cc_run_i || return
    test "$_cross_compile" = "yes" && return    # don't run in this case
    $_cc_run_o
}
