conf_module cxx_optimize

_cxx_optimize=

# Same as with cxx test. Code duplication here, but that will probably change
# a lot if the lists of C and C++ compilers start to differ. See conf_cxx.sh

conf_test_cxx_optimize() {
    conf_depends_on cxx
    conf_depends_on debug

    tmp=$1
    test -n "$_debug" && tmp=debug

    case "$_cxx_vendor" in
    suncc)
        case "$tmp" in
        none|debug) _cxx_optimize= ;;
        size)       _cxx_optimize=-xspace ;;
        low)        _cxx_optimize=-xO1 ;;
        high)       _cxx_optimize=-xO4 ;;
        extreme)    _cxx_optimize=-xO5 ;;
        medium|*)   _cxx_optimize=-xO3 ;;
        esac
        ;;
    gnu|icc)
        case "$tmp" in
        none|debug) _cxx_optimize=-O0 ;;
        size)       _cxx_optimize=-Os ;;
        low)        _cxx_optimize=-O1 ;;
        high)       _cxx_optimize=-O3 ;;
        extreme)    _cxx_optimize=-O3 ;;
        medium|*)   _cxx_optimize=-O2 ;;
        esac
        ;;
    *)
        _cxx_optimize=-O
        ;;
    esac

    echocheck "generic $_cxx optimization"
    if test -n "$tmp" ; then
        _res_comment="using $_cxx_optimize"
        echores "$tmp"
    else
        _res_comment="using $_cxx_optimize"
        echores "medium"
    fi
}
