conf_module cxx_run

_cxx_run_i=
_cxx_run_o=

conf_test_cxx_run() {
    conf_depends_on cxx

    test -z "$_cxx" &&
        die "There is no C++ compiler, so I can't do any further checks!"

    conf_depends_on tempdir

    test -z "$_tempdir" &&
        die "There is no temporary diskspace available, so I can't do any further checks!"

    _cxx_run_i="$_tempdir/conf-test-$$.cpp"
    _cxx_run_o="$_tempdir/conf-test-$$.o"
    rm -f $_cxx_run_i $_cxx_run_o

    conf_depends_on ldd

    conf_mark_test_done cxx_run
}

cxx_run() {
    echo >> $_conflog
    cat $_cxx_run_i >> $_conflog
    echo >> $_conflog
    echo "$_cxx $CFLAGS $CXXCPPFLAGS $_inc_extra $_lib_extra -o $_cxx_run_o $@" >> $_conflog
    rm -f $_cxx_run_o
    $_cxx $CFLAGS $CXXCPPFLAGS $_inc_extra $_lib_extra -o $_cxx_run_o $@ >> $_conflog 2>&1
    tmp="$?"
    echo >> $_conflog
    if test -n "$_ldd" ; then
        echo "ldd $_cxx_run_o" >> $_conflog
        $_ldd $_cxx_run_o >> $_conflog
        echo >> $_conflog
    fi
    return $tmp
}
