conf_module os

_os=
_os_release=

conf_add_options "expert" \
    "--os=NAME;OS;specify the target operating system;
    |--os-release=RELEASE;OS_RELEASE;override operating system version;"

conf_test_os() {
    conf_depends_on tolower
    conf_depends_on target

    if test -n "$OS_RELEASE" ; then
        _os_release=`echo "$OS_RELEASE" | $_tolower`
    fi
    if test -n "$OS" ; then
        _os=`echo "$OS" | $_tolower`
        echocheck "operating system"
        if test -z "$_os_release" ; then
            echores "$_os"
        else
            echores "$_os ($_os_release)"
        fi
        conf_mark_test_done os
        return
    fi

    conf_depends_on uname

    echocheck "operating system"

    if test -n "$_uname" ; then
        _os=`$_uname -s 2>&1 | $_tolower`
        test -z "$_os_release" && _os_release=`$_uname -r 2>&1 | $_tolower`
    fi

    if test -z "$_os" ; then
        # just see if cc knows -dumpmachine and outputs enough fields
        _os=`cc -dumpmachine 2>&1 | cut_fast '-' 3 | $_tolower`
    fi

    _os=`conf_known_os "$_os"`

    test -z "$_os" && _os=unknown

    if test -z "$_os_release" ; then
        echores "$_os"
    else
        echores "$_os ($_os_release)"
    fi
    conf_mark_test_done os
    test -n "$_os"
}

conf_known_os() {
    case "$1" in
        nonstop_kern*)  echo nsk ;;
        power_unix*)    echo powerunix ;;
        nonstop-ux*)    echo nonstopux ;;
        dynix/ptx*)     echo dynixptx ;;
        super-ux*)  echo superux ;;
        rhapsody*)  echo rhapsody ;;
        powermax*)  echo powermax ;;
        mach_bsd*)  echo mach_bsd ;;
        convexos*)  echo convexos ;;
        unix_sv*)   echo sysv ;;
        solaris*)   echo sunos ;;
        solaris2)   echo solaris2 ;;
        procnto*)   echo qnx ;;
        openbsd*)   echo openbsd ;;
        news-os*)   echo newsos ;;
        morphos*)   echo morphos ;;
        machten*)   echo machten ;;
        interix*)   echo interix ;;
        freebsd*)   echo freebsd ;;
        dolphin*)   echo dolphinos ;;
        bsd/386*)   echo bsdi ;;
        amigaos*)   echo amigaos ;;
        unicos*)    echo unicos ;;
        ultrix*)    echo ultrix ;;
        tops-20)    echo tops20 ;;
        tops-10)    echo tops10 ;;
        riscos*)    echo riscos ;;
        netbsd*)    echo netbsd ;;
        lynxos*)    echo lynxos ;;
        darwin*)    echo darwin ;;
        cygwin*)    echo cygwin ;;
        bsd/os*)    echo bsdos ;;
        bsd/os*)    echo bsdi ;;
        atheos*)    echo atheos ;;
        4.4bsd*)    echo bsd ;;
        tenex*)     echo tenex ;;
        sunos*)     echo sunos ;;
        sinix*)     echo sinix ;;
        posix*)     echo sysv ;;
        plan9*)     echo plan9 ;;
        minix*)     echo minix ;;
        mingw*)     echo mingw ;;
        lites*)     echo lites ;;
        linux*)     echo linux ;;
        hp-ux*)     echo hpux ;;
        hi-ux*)     echo hiux ;;
        cx/ux*)     echo cxux ;;
        utek*)  echo utek ;;
        risc*)  echo riscix ;;
        mach*)  echo mach ;;
        irix*)  echo irix ;;
        dgux*)  echo dgux ;;
        ctix*)  echo ctix ;;
        clix*)  echo clix ;;
        bosx*)  echo bosx ;;
        beos*)  echo beos ;;
        a/ux*)  echo aux ;;
        vos*)   echo vos ;;
        qnx*)   echo qnx ;;
        osf*)   echo osf ;;
        os/2)   echo os2 ;;
        mpe*)   echo mpeix ;;
        gnu*)   echo gnu ;;
        aix*)   echo aix ;;
        pw*)    echo pw32 ;;
        its)    echo its ;;
        *system_v*)     echo sysv ;;
        *mint*)     echo mint ;;
        *dos)   echo msdos ;;
        *bsd)   echo bsd ;;
        *) echo ;; 
    esac
}
