conf_module tolower

_tolower=

conf_test_tolower() {
    conf_mark_test_done tolower
    conf_depends_on tr  && _tolower=conf_tolower_tr && return
    conf_depends_on sed && _tolower=conf_tolower_sed && return
    conf_depends_on awk && _tolower=conf_tolower_awk && return

    die "You really need to have either tr, sed or awk installed!"
}

conf_tolower_tr() {
    $_tr ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz
}

conf_tolower_sed() {
    $_sed 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'
}

conf_tolower_awk() {
    case "$_awk" in
    gawk|mawk|mksawk)
        $_awk '{ print tolower($0) }'
        ;;
    nawk|awk|*)
        $_awk '
        BEGIN {
            LC="abcdefghijklmnopqrstuvwxyz";
            UC="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        } {
            out="";
            for(i=1;i<=length($0);i++) {
                c=substr($0,i,1);
                j=index(UC,c);
                if (j>0) {
                    out=out substr(LC,j,1);
                } else {
                    out=out c;
                }
            }
            printf("%s\n", out);
        }'
        ;;
    esac
}
