conf_module toupper

_toupper=

conf_test_toupper() {
    conf_mark_test_done toupper
    conf_depends_on tr && _toupper=conf_toupper_tr && return
    conf_depends_on sed && _toupper=conf_toupper_sed && return
    conf_depends_on awk && _toupper=conf_toupper_awk && return

    die "You really need to have either tr, sed or awk installed!"
}

conf_toupper_tr() {
    $_tr a-z A-Z
}

conf_toupper_sed() {
    $_sed 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'
}

conf_toupper_awk() {
    case "$_awk" in
    gawk|mawk|mksawk)
        $_awk '{ print toupper($0) }'
        ;;
    nawk|awk|*)
        $_awk '
        BEGIN {
            LC="abcdefghijklmnopqrstuvwxyz";
            UC="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        } {
            out="";
            for(i=1;i<=length($0);i++) {
                c=substr($0,i,1);
                j=index(LC,c);
                if (j>0) {
                    out=out substr(UC,j,1);
                } else {
                    out=out c;
                }
            }
            printf("%s\n", out);
        }'
        ;;
    esac
}
