/* cpuinfo-alpha.c  - small helper utility if there is no /proc/cpuinfo
 *
 * based on the code in MPlayer's (old) configure (C) FIXME author
 *
 * (C)2006 Ivo van Poorten
 */

#include <stdio.h>

int main(int argc, char **argv) {
    unsigned long ver, mask;
    char *model = "unknown";

    asm("implver %0" : "=r" (ver));
    asm("amask %1, %0" : "=r" (mask) : "r" (-1));

    mask=~mask;

    switch (ver) {
        case 0: model="ev4"; break;
        case 1: switch (mask) {
            case 0x0000: model="ev5"; break;
            case 0x0001: model="ev56"; break;
            case 0x0101: model="pca56"; break;
        } break;
        case 2: switch (mask) {
            case 0x0303: model="ev6"; break;
            case 0x0307: model="ev67"; break;
            case 0x1307: model="ev68"; break;
        } break;
        default:
            break;
    }

    printf("cpu\t\t: Alpha\n");
    printf("cpu model\t: %s\n", model);

    return 0;
}
